/* OOAExampleController.m created by bungi on Fri 14-Nov-1997 */

#import "OOAExampleController.h"
#import "OOAInternalRefCountExample.h"

@implementation OOAExampleController

- init;
{
    if (!(self = [super init]))
        return nil;

    array = [[NSMutableArray alloc] init];
    dictionary = [[NSMutableDictionary alloc] init];

    return self;
}

- (void) dealloc;
{
    [array release];
    [dictionary release];
    [super dealloc];
}

- (void) leak: (id) sender;
{
    // Leaks the old array
    array = [[NSMutableArray alloc] init];
}

- (void) cacheData: (id) sender;
{
    NSObject *object;
    
    // This object will hang around for a while.
    object = [[NSObject alloc] init];
    [object performSelector: @selector(release) withObject: nil afterDelay: 30];
}

- (void) zombie: (id) sender;
{
    NSObject *object;

    object = [[NSObject alloc] init];
    [object release];
    [object release];
}

- (void) internalReferences: (id) sender;
{
    OOAInternalRefCountExample *example;
    unsigned int i;

    // Ref count starts at one
    example = [[OOAInternalRefCountExample alloc] init];

    // Increment the retain count very high
    for (i = 0; i < 500; i++)
        [example retain];

    // Go back to one
    for (i = 0; i < 500; i++)
        [example release];

    // This will dealloc the object
    [example release];
}

@end
